
var brocra = /^\s*file:\/\/.+|^\s*mailto:.+/i;

function get_size_url_obj(obj) {
  if (obj == null) return;
  if (!obj.src.match(/\/lowsrc\.gif$/)) return;
  var req = new ActiveXObject("Microsoft.XMLHTTP");
  if (req == null) {
    obj.src = obj.title;
    return;
  }
  req.onreadystatechange = function() {
    var num, len;
    if (obj.src.match(/\/cancel\.gif$|\/error\.gif$/)) {
      req = null;
      return;
    }
    if (req.readyState == 4) {
      if (req.status == 200) {
        len = req.getResponseHeader('Content-Length');
        num = parseInt(len);
        if (len == "" || num < 0)
          obj.src = "./error.gif";
        else if (num > 1024*1024*2)
          obj.src = "./big.gif";
        else
          obj.src = obj.title;
      } else if (req.status == 0 || req.status == 403) {
        obj.src = obj.title;
      } else if (req.status == 404|| req.status == 503 || req.status >= 12000) {
        obj.src = "./error.gif";
      } else {
        //alert(req.status+":"+obj.title);
        obj.src = obj.title;
      }
      req = null;
    }
  }
  try {
    req.open("HEAD", obj.title, true);
    req.send(null);
  } catch(e) {
    req = null;
    obj.src = obj.title;
  }
}

function writeURL(num, flag1, flag2) {
  var strTmp = new String("");
  var strURL = new String("");
  for (var i=num; i<num+16 && i<urls.length-1; i++) {
    strURL = urls[i];
    if ( strURL.match(brocra) || (flag1 && groCheck(strURL)) ) {
      strTmp += "<a href=JavaScript:void(0)><img src=./stop.gif title='"+strURL+"'></a>\n";
    } else {
      strTmp += "<a href='" + strURL + "'><img src='";
      strTmp += (flag2 ? "./lowsrc.gif" : strURL);
      strTmp += "' title='" + strURL + "'></a>\n";
    }
    index = i - num;
    strTmp += "<a href=JavaScript:void(0) onclick=\"document.images["+index+"].src='./cancel.gif';return false;\">_</a>\n";
  }
  msg.innerHTML = strTmp;

  if (flag2) {
    for (var i=0; i < document.images.length; i++)
      get_size_url_obj(document.images[i]);
  }
}

function listURL() {
  var strList = new String("");
  var strURL = new String("");
  for (var i=0; i<urls.length-1; i++) {
    strURL = urls[i];
    var p = parseInt(i / 16) + 1;
    var num = (p - 1) * 16;
    if ( strURL.match(brocra) || groCheck(strURL) ) {
      strList += "<nobr>&nbsp;(<a href='#' onclick='writeURL("+num+",grochk.checked,bigchk.checked);page.selectedIndex="+(p-1)+";return false;'>"+
        p+"P</a>)&nbsp;<font color=gray>"+strURL+"</font></nobr><br>\n";
    } else {
      strList += "<nobr>&nbsp;(<a href='#' onclick='writeURL("+num+",grochk.checked,bigchk.checked);page.selectedIndex="+(p-1)+";return false;'>"+
        p+"P</a>)&nbsp;<a href="+strURL+">"+strURL+"</a></nobr><br>\n";
    }
  }
  msg.innerHTML = strList;
}

function stop() {
  for (var i=0; i<document.images.length; i++) {
    if (!document.images[i].complete || document.images[i].src.match(/\/lowsrc\.gif$/))
      document.images[i].src = "./cancel.gif";
  }
}

function refresh(flag1, flag2) {
  if (urls.length > 1)
    writeURL(parseInt(page.value), flag1, flag2);
}

function sortAsc() {
  urls.sort();
  urls.shift();
  urls.push("");
  refresh();
}

function sortDesc() {
  urls.sort();
  urls.reverse();
  refresh();
}
